import { Configuration } from '../util/configuration';
import { GetCurrentUser200ResponseData, GetOrganization200ResponseData, GetConversationLogs200ResponseData, StartOutboundCall200ResponseData, CreateCampaign201ResponseData, GetCampaignById200ResponseData, GetCampaigns200ResponseDataInner, GetKnowledgeBaseById200Response, GetKnowledgeBases200Response, GetKnowledgeBaseItems200Response, GetAgentTemplates200ResponseDataInner, AgentDTO } from './api';
import { AxiosPromise, RawAxiosRequestConfig } from 'axios';
import { BaseAPI } from './base';
/**
 * AtomsClient - object-oriented interface
 * @export
 * @class AtomsClient
 * @extends {BaseAPI}
 */
export declare class AtomsClient extends BaseAPI {
    private agentTemplatesApi;
    private agentsApi;
    private callsApi;
    private campaignsApi;
    private knowledgeBaseApi;
    private logsApi;
    private organizationApi;
    private userApi;
    constructor(configuration?: Configuration);
    createAgentFromTemplate(createAgentFromTemplateRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<string>;
    getAgentTemplates(options?: RawAxiosRequestConfig): AxiosPromise<Array<GetAgentTemplates200ResponseDataInner>>;
    createAgent(createAgentRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<string>;
    deleteAgent(id: string, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    getAgentById(id: string, options?: RawAxiosRequestConfig): AxiosPromise<AgentDTO>;
    getAgents(page?: number, offset?: number, search?: string, options?: RawAxiosRequestConfig): AxiosPromise<Array<AgentDTO>>;
    updateAgent(id: string, updateAgentRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<string>;
    startOutboundCall(startOutboundCallRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<StartOutboundCall200ResponseData>;
    createCampaign(createCampaignRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<CreateCampaign201ResponseData>;
    deleteCampaign(id: string, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    getCampaignById(id: string, options?: RawAxiosRequestConfig): AxiosPromise<GetCampaignById200ResponseData>;
    getCampaigns(getCampaignsRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<Array<GetCampaigns200ResponseDataInner>>;
    pauseCampaign(id: string, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    startCampaign(id: string, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    createKnowledgeBase(createKnowledgeBaseRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<string>;
    deleteKnowledgeBase(id: string, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    deleteKnowledgeBaseItem(knowledgeBaseId: string, knowledgeBaseItemId: string, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    getKnowledgeBaseById(id: string, options?: RawAxiosRequestConfig): AxiosPromise<GetKnowledgeBaseById200Response>;
    getKnowledgeBases(options?: RawAxiosRequestConfig): AxiosPromise<GetKnowledgeBases200Response>;
    getKnowledgeBaseItems(id: string, options?: RawAxiosRequestConfig): AxiosPromise<GetKnowledgeBaseItems200Response>;
    uploadMediaToKnowledgeBase(id: string, media: File, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    uploadTextToKnowledgeBase(id: string, uploadTextToKnowledgeBaseRequest: any, options?: RawAxiosRequestConfig): AxiosPromise<boolean>;
    getConversationLogs(id: string, options?: RawAxiosRequestConfig): AxiosPromise<GetConversationLogs200ResponseData>;
    getOrganization(options?: RawAxiosRequestConfig): AxiosPromise<GetOrganization200ResponseData>;
    getCurrentUser(options?: RawAxiosRequestConfig): AxiosPromise<GetCurrentUser200ResponseData>;
}
