"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.AtomsClient = void 0;
var api_1 = require("./api");
var api_2 = require("./api");
var api_3 = require("./api");
var api_4 = require("./api");
var api_5 = require("./api");
var api_6 = require("./api");
var api_7 = require("./api");
var api_8 = require("./api");
var base_1 = require("./base");
/**
 * AtomsClient - object-oriented interface
 * @export
 * @class AtomsClient
 * @extends {BaseAPI}
 */
var AtomsClient = /** @class */ (function (_super) {
    __extends(AtomsClient, _super);
    function AtomsClient(configuration) {
        var _this = _super.call(this, configuration) || this;
        _this.agentTemplatesApi = new api_1.AgentTemplatesApi(configuration);
        _this.agentsApi = new api_2.AgentsApi(configuration);
        _this.callsApi = new api_3.CallsApi(configuration);
        _this.campaignsApi = new api_4.CampaignsApi(configuration);
        _this.knowledgeBaseApi = new api_5.KnowledgeBaseApi(configuration);
        _this.logsApi = new api_6.LogsApi(configuration);
        _this.organizationApi = new api_7.OrganizationApi(configuration);
        _this.userApi = new api_8.UserApi(configuration);
        return _this;
    }
    // Agent Templates API methods
    AtomsClient.prototype.createAgentFromTemplate = function (createAgentFromTemplateRequest, options) {
        return this.agentTemplatesApi.createAgentFromTemplate(createAgentFromTemplateRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getAgentTemplates = function (options) {
        return this.agentTemplatesApi.getAgentTemplates(options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // Agents API methods
    AtomsClient.prototype.createAgent = function (createAgentRequest, options) {
        return this.agentsApi.createAgent(createAgentRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.deleteAgent = function (id, options) {
        return this.agentsApi.deleteAgent(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getAgentById = function (id, options) {
        return this.agentsApi.getAgentById(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getAgents = function (page, offset, search, options) {
        return this.agentsApi.getAgents(page, offset, search, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.updateAgent = function (id, updateAgentRequest, options) {
        return this.agentsApi.updateAgent(id, updateAgentRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // Calls API methods
    AtomsClient.prototype.startOutboundCall = function (startOutboundCallRequest, options) {
        return this.callsApi.startOutboundCall(startOutboundCallRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // Campaigns API methods
    AtomsClient.prototype.createCampaign = function (createCampaignRequest, options) {
        return this.campaignsApi.createCampaign(createCampaignRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.deleteCampaign = function (id, options) {
        return this.campaignsApi.deleteCampaign(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getCampaignById = function (id, options) {
        return this.campaignsApi.getCampaignById(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getCampaigns = function (getCampaignsRequest, options) {
        return this.campaignsApi.getCampaigns(getCampaignsRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.pauseCampaign = function (id, options) {
        return this.campaignsApi.pauseCampaign(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.startCampaign = function (id, options) {
        return this.campaignsApi.startCampaign(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // Knowledge Base API methods
    AtomsClient.prototype.createKnowledgeBase = function (createKnowledgeBaseRequest, options) {
        return this.knowledgeBaseApi.createKnowledgeBase(createKnowledgeBaseRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.deleteKnowledgeBase = function (id, options) {
        return this.knowledgeBaseApi.deleteKnowledgeBase(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.deleteKnowledgeBaseItem = function (knowledgeBaseId, knowledgeBaseItemId, options) {
        return this.knowledgeBaseApi.deleteKnowledgeBaseItem(knowledgeBaseId, knowledgeBaseItemId, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getKnowledgeBaseById = function (id, options) {
        return this.knowledgeBaseApi.getKnowledgeBaseById(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getKnowledgeBases = function (options) {
        return this.knowledgeBaseApi.getKnowledgeBases(options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.getKnowledgeBaseItems = function (id, options) {
        return this.knowledgeBaseApi.getKnowledgeBaseItems(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.uploadMediaToKnowledgeBase = function (id, media, options) {
        return this.knowledgeBaseApi.uploadMediaToKnowledgeBase(id, media, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    AtomsClient.prototype.uploadTextToKnowledgeBase = function (id, uploadTextToKnowledgeBaseRequest, options) {
        return this.knowledgeBaseApi.uploadTextToKnowledgeBase(id, uploadTextToKnowledgeBaseRequest, options).then(function (response) {
            return Promise.resolve({
                data: response.data.status,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // Logs API methods
    AtomsClient.prototype.getConversationLogs = function (id, options) {
        return this.logsApi.getConversationLogs(id, options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // Organization API methods
    AtomsClient.prototype.getOrganization = function (options) {
        return this.organizationApi.getOrganization(options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    // User API methods
    AtomsClient.prototype.getCurrentUser = function (options) {
        return this.userApi.getCurrentUser(options).then(function (response) {
            return Promise.resolve({
                data: response.data.data,
                status: response.status,
                statusText: response.statusText,
                headers: response.headers,
                config: response.config
            });
        });
    };
    return AtomsClient;
}(base_1.BaseAPI));
exports.AtomsClient = AtomsClient;
