"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var vitest_1 = require("vitest");
var WavesClient_1 = require("../../waves/WavesClient");
var configuration_1 = require("../../util/configuration");
var fs = __importStar(require("fs"));
var ajv_1 = __importDefault(require("ajv"));
var axios_1 = __importDefault(require("axios"));
var FormData = require('form-data');
(0, vitest_1.describe)('Voice Cloning', function () {
    var configuration = new configuration_1.Configuration({
        basePath: 'https://waves-api.smallest.ai'
    });
    var wavesClient = new WavesClient_1.WavesClient(configuration);
    var ajv = new ajv_1.default();
    var addVoiceResponseSchema = {
        type: 'object',
        properties: {
            message: { type: 'string', nullable: true },
            data: {
                type: 'object',
                properties: {
                    voiceId: { type: 'string' },
                    model: { type: 'string' },
                    status: { type: 'string' }
                },
                required: ['voiceId', 'model', 'status'],
                nullable: true
            }
        }
    };
    var getVoicesResponseSchema = {
        type: 'object',
        properties: {
            voices: {
                type: 'array',
                items: {
                    type: 'object',
                    properties: {
                        voiceId: { type: 'string' },
                        displayName: { type: 'string' },
                        accent: { type: 'string', nullable: true },
                        tags: {
                            type: 'array',
                            items: { type: 'string' },
                            nullable: true
                        },
                        model: { type: 'string', nullable: true },
                        status: { type: 'string', nullable: true },
                        createdAt: { type: 'string', nullable: true }
                    },
                    required: ['voiceId', 'displayName']
                },
                nullable: true
            }
        }
    };
    var deleteVoiceResponseSchema = {
        type: 'object',
        properties: {
            success: { type: 'boolean', nullable: true },
            voiceId: { type: 'string' }
        },
        required: ['voiceId']
    };
    var validateAddVoice = ajv.compile(addVoiceResponseSchema);
    var validateGetVoices = ajv.compile(getVoicesResponseSchema);
    var validateDeleteVoice = ajv.compile(deleteVoiceResponseSchema);
    (0, vitest_1.it)('should add a new voice and validate response structure', function () { return __awaiter(void 0, void 0, void 0, function () {
        var filePath, fileContent, file, response, isValid, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    filePath = './src/tests/waves/voice-for-cloning.wav';
                    fileContent = fs.readFileSync(filePath);
                    file = new File([fileContent], filePath, { type: 'audio/wav' });
                    return [4 /*yield*/, wavesClient.addVoiceToModel('Test Voice', file, {})];
                case 1:
                    response = _a.sent();
                    isValid = validateAddVoice(response.data);
                    if (!isValid && validateAddVoice.errors) {
                        console.error('Validation errors:', validateAddVoice.errors);
                    }
                    (0, vitest_1.expect)(isValid).toBe(true);
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    console.error('Error in addVoiceToModel test:', error_1);
                    throw error_1;
                case 3: return [2 /*return*/];
            }
        });
    }); });
    (0, vitest_1.it)('should list voices and validate response structure', function () { return __awaiter(void 0, void 0, void 0, function () {
        var response, isValid, error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, wavesClient.getClonedVoices()];
                case 1:
                    response = _a.sent();
                    isValid = validateGetVoices(response.data);
                    if (!isValid && validateGetVoices.errors) {
                        console.error('Validation errors:', validateGetVoices.errors);
                    }
                    (0, vitest_1.expect)(isValid).toBe(true);
                    return [3 /*break*/, 3];
                case 2:
                    error_2 = _a.sent();
                    console.error('Error in getClonedVoices test:', error_2);
                    throw error_2;
                case 3: return [2 /*return*/];
            }
        });
    }); });
    (0, vitest_1.it)('should delete a voice and validate response structure', function () { return __awaiter(void 0, void 0, void 0, function () {
        var formData, fileStream, addResponse, voiceIdToDelete, response, isValid, error_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    formData = new FormData();
                    formData.append('displayName', 'Test Voice');
                    fileStream = fs.createReadStream('./src/tests/waves/voice-for-cloning.wav');
                    formData.append('file', fileStream);
                    return [4 /*yield*/, axios_1.default.post('https://waves-api.smallest.ai/api/v1/lightning-large/add_voice', formData, {
                            headers: __assign({ 'Authorization': "Bearer ".concat(process.env.SMALLEST_API_KEY) }, formData.getHeaders()),
                            timeout: 50000
                        })];
                case 1:
                    addResponse = _a.sent();
                    voiceIdToDelete = addResponse.data.data.voiceId;
                    return [4 /*yield*/, wavesClient.deleteVoiceClone({ voiceId: voiceIdToDelete })];
                case 2:
                    response = _a.sent();
                    isValid = validateDeleteVoice(response.data);
                    if (!isValid && validateDeleteVoice.errors) {
                        console.error('Validation errors:', validateDeleteVoice.errors);
                    }
                    (0, vitest_1.expect)(isValid).toBe(true);
                    return [3 /*break*/, 4];
                case 3:
                    error_3 = _a.sent();
                    console.error('Error in deleteVoiceClone test:', error_3);
                    throw error_3;
                case 4: return [2 /*return*/];
            }
        });
    }); });
});
