/**
 * API Endpoint to interact with Waves API.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../util/configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import type { RequestArgs } from './base';
import { BaseAPI } from './base';
/**
 *
 * @export
 * @interface AddVoiceToModel200Response
 */
export interface AddVoiceToModel200Response {
    /**
     * Message if the voice clone was created successfully.
     * @type {string}
     * @memberof AddVoiceToModel200Response
     */
    'message'?: string;
    /**
     *
     * @type {AddVoiceToModel200ResponseData}
     * @memberof AddVoiceToModel200Response
     */
    'data'?: AddVoiceToModel200ResponseData;
}
/**
 *
 * @export
 * @interface AddVoiceToModel200ResponseData
 */
export interface AddVoiceToModel200ResponseData {
    /**
     * Unique Voice ID.
     * @type {string}
     * @memberof AddVoiceToModel200ResponseData
     */
    'voiceId': string;
    /**
     * Model used to generate the voice.
     * @type {string}
     * @memberof AddVoiceToModel200ResponseData
     */
    'model': string;
    /**
     * Status of the voice creation.
     * @type {string}
     * @memberof AddVoiceToModel200ResponseData
     */
    'status': string;
}
/**
 *
 * @export
 * @interface AddVoiceToModel400Response
 */
export interface AddVoiceToModel400Response {
    /**
     * Error type
     * @type {string}
     * @memberof AddVoiceToModel400Response
     */
    'error'?: string;
    /**
     * Error message
     * @type {string}
     * @memberof AddVoiceToModel400Response
     */
    'message'?: string;
}
/**
 *
 * @export
 * @interface DeleteVoiceClone200Response
 */
export interface DeleteVoiceClone200Response {
    /**
     * Status if the voice clone was deleted successfully.
     * @type {boolean}
     * @memberof DeleteVoiceClone200Response
     */
    'success'?: boolean;
    /**
     * Voice ID of the deleted voice clone.
     * @type {string}
     * @memberof DeleteVoiceClone200Response
     */
    'voiceId': string;
}
/**
 *
 * @export
 * @interface DeleteVoiceCloneRequest
 */
export interface DeleteVoiceCloneRequest {
    /**
     * The unique identifier of the voice clone to delete.
     * @type {string}
     * @memberof DeleteVoiceCloneRequest
     */
    'voiceId': string;
}
/**
 *
 * @export
 * @interface GetClonedVoices200Response
 */
export interface GetClonedVoices200Response {
    /**
     * List of available voices.
     * @type {Array<GetClonedVoices200ResponseVoicesInner>}
     * @memberof GetClonedVoices200Response
     */
    'voices'?: Array<GetClonedVoices200ResponseVoicesInner>;
}
/**
 *
 * @export
 * @interface GetClonedVoices200ResponseVoicesInner
 */
export interface GetClonedVoices200ResponseVoicesInner {
    /**
     * Display name for the voice.
     * @type {string}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'displayName': string;
    /**
     * Accent of the voice.
     * @type {string}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'accent'?: string;
    /**
     * List of tags associated with the voice.
     * @type {Array<string>}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'tags'?: Array<string>;
    /**
     * Unique Voice ID.
     * @type {string}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'voiceId': string;
    /**
     * Model used to generate the voice.
     * @type {string}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'model'?: string;
    /**
     * Status of the voice generation.
     * @type {string}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'status'?: string;
    /**
     * Date and time the voice was created.
     * @type {string}
     * @memberof GetClonedVoices200ResponseVoicesInner
     */
    'createdAt'?: string;
}
/**
 *
 * @export
 * @interface GetWavesVoices200Response
 */
export interface GetWavesVoices200Response {
    /**
     * List of available voices.
     * @type {Array<GetWavesVoices200ResponseVoicesInner>}
     * @memberof GetWavesVoices200Response
     */
    'voices'?: Array<GetWavesVoices200ResponseVoicesInner>;
}
/**
 *
 * @export
 * @interface GetWavesVoices200ResponseVoicesInner
 */
export interface GetWavesVoices200ResponseVoicesInner {
    /**
     * Unique Voice ID.
     * @type {string}
     * @memberof GetWavesVoices200ResponseVoicesInner
     */
    'voiceId': string;
    /**
     * Display name for the voice.
     * @type {string}
     * @memberof GetWavesVoices200ResponseVoicesInner
     */
    'displayName': string;
    /**
     *
     * @type {GetWavesVoices200ResponseVoicesInnerTags}
     * @memberof GetWavesVoices200ResponseVoicesInner
     */
    'tags'?: GetWavesVoices200ResponseVoicesInnerTags;
}
/**
 * List of tags associated with the voice.
 * @export
 * @interface GetWavesVoices200ResponseVoicesInnerTags
 */
export interface GetWavesVoices200ResponseVoicesInnerTags {
    /**
     * Language of the voice.
     * @type {Array<string>}
     * @memberof GetWavesVoices200ResponseVoicesInnerTags
     */
    'language'?: Array<string>;
    /**
     * Accent of the voice.
     * @type {string}
     * @memberof GetWavesVoices200ResponseVoicesInnerTags
     */
    'accent'?: string;
    /**
     * Gender of the voice.
     * @type {string}
     * @memberof GetWavesVoices200ResponseVoicesInnerTags
     */
    'gender'?: string;
}
/**
 *
 * @export
 * @interface LightningLargeRequest
 */
export interface LightningLargeRequest {
    /**
     * This parameter controls word repetition and skipping. Decrease it to prevent skipped words, and increase it to prevent repetition.
     * @type {number}
     * @memberof LightningLargeRequest
     */
    'consistency'?: number;
    /**
     * This parameter controls the similarity between the generated speech and the reference audio. Increase it to make the speech more similar to the reference audio.
     * @type {number}
     * @memberof LightningLargeRequest
     */
    'similarity'?: number;
    /**
     * Enhances speech quality at the cost of increased latency.
     * @type {number}
     * @memberof LightningLargeRequest
     */
    'enhancement'?: number;
    /**
     * The text to convert to speech.
     * @type {string}
     * @memberof LightningLargeRequest
     */
    'text': string;
    /**
     * The voice identifier to use for speech generation.
     * @type {string}
     * @memberof LightningLargeRequest
     */
    'voice_id': string;
    /**
     * Whether to add WAV header to the output.
     * @type {boolean}
     * @memberof LightningLargeRequest
     */
    'add_wav_header'?: boolean;
    /**
     * The sample rate for the generated audio.
     * @type {number}
     * @memberof LightningLargeRequest
     */
    'sample_rate'?: number;
    /**
     * The speed of the generated speech.
     * @type {number}
     * @memberof LightningLargeRequest
     */
    'speed'?: number;
    /**
     * Determines how numbers are spelled out. If set to \'en\', numbers will be read as individual digits in English. If set to \'hi\', numbers will be read as individual digits in Hindi.
     * @type {string}
     * @memberof LightningLargeRequest
     */
    'language'?: LightningLargeRequestLanguageEnum;
}
export declare const LightningLargeRequestLanguageEnum: {
    readonly En: "en";
    readonly Hi: "hi";
    readonly Ta: "ta";
    readonly Fr: "fr";
    readonly De: "de";
    readonly Pl: "pl";
};
export type LightningLargeRequestLanguageEnum = typeof LightningLargeRequestLanguageEnum[keyof typeof LightningLargeRequestLanguageEnum];
/**
 *
 * @export
 * @interface LightningRequest
 */
export interface LightningRequest {
    /**
     * The text to convert to speech.
     * @type {string}
     * @memberof LightningRequest
     */
    'text': string;
    /**
     * The voice identifier to use for speech generation.
     * @type {string}
     * @memberof LightningRequest
     */
    'voice_id': string;
    /**
     * Whether to add WAV header to the output.
     * @type {boolean}
     * @memberof LightningRequest
     */
    'add_wav_header'?: boolean;
    /**
     * The sample rate for the generated audio.
     * @type {number}
     * @memberof LightningRequest
     */
    'sample_rate'?: number;
    /**
     * The speed of the generated speech.
     * @type {number}
     * @memberof LightningRequest
     */
    'speed'?: number;
    /**
     * Determines how numbers are spelled out. If set to \'en\', numbers will be read as individual digits in English. If set to \'hi\', numbers will be read as individual digits in Hindi.
     * @type {string}
     * @memberof LightningRequest
     */
    'language'?: LightningRequestLanguageEnum;
}
export declare const LightningRequestLanguageEnum: {
    readonly En: "en";
    readonly Hi: "hi";
    readonly Ta: "ta";
    readonly Fr: "fr";
    readonly De: "de";
    readonly Pl: "pl";
};
export type LightningRequestLanguageEnum = typeof LightningRequestLanguageEnum[keyof typeof LightningRequestLanguageEnum];
/**
 *
 * @export
 * @interface SynthesizeLightningSpeech400Response
 */
export interface SynthesizeLightningSpeech400Response {
    /**
     * Error type.
     * @type {string}
     * @memberof SynthesizeLightningSpeech400Response
     */
    'error'?: string;
    /**
     * Error message.
     * @type {string}
     * @memberof SynthesizeLightningSpeech400Response
     */
    'message'?: string;
}
/**
 * LightningApi - axios parameter creator
 * @export
 */
export declare const LightningApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Converts provided text to speech using the Lightning model.
     * @summary Generate speech from text (Lightning)
     * @param {LightningRequest} lightningRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    synthesizeLightningSpeech: (lightningRequest: LightningRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * LightningApi - functional programming interface
 * @export
 */
export declare const LightningApiFp: (configuration?: Configuration) => {
    /**
     * Converts provided text to speech using the Lightning model.
     * @summary Generate speech from text (Lightning)
     * @param {LightningRequest} lightningRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    synthesizeLightningSpeech(lightningRequest: LightningRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>>;
};
/**
 * LightningApi - factory interface
 * @export
 */
export declare const LightningApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Converts provided text to speech using the Lightning model.
     * @summary Generate speech from text (Lightning)
     * @param {LightningRequest} lightningRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    synthesizeLightningSpeech(lightningRequest: LightningRequest, options?: RawAxiosRequestConfig): AxiosPromise<File>;
};
/**
 * LightningApi - object-oriented interface
 * @export
 * @class LightningApi
 * @extends {BaseAPI}
 */
export declare class LightningApi extends BaseAPI {
    /**
     * Converts provided text to speech using the Lightning model.
     * @summary Generate speech from text (Lightning)
     * @param {LightningRequest} lightningRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LightningApi
     */
    synthesizeLightningSpeech(lightningRequest: LightningRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<File, any>>;
}
/**
 * LightningLargeApi - axios parameter creator
 * @export
 */
export declare const LightningLargeApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    streamLightningLargeSpeech: (lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    synthesizeLightningLargeSpeech: (lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * LightningLargeApi - functional programming interface
 * @export
 */
export declare const LightningLargeApiFp: (configuration?: Configuration) => {
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    streamLightningLargeSpeech(lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    synthesizeLightningLargeSpeech(lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>>;
};
/**
 * LightningLargeApi - factory interface
 * @export
 */
export declare const LightningLargeApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    streamLightningLargeSpeech(lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig): AxiosPromise<void>;
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    synthesizeLightningLargeSpeech(lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig): AxiosPromise<File>;
};
/**
 * LightningLargeApi - object-oriented interface
 * @export
 * @class LightningLargeApi
 * @extends {BaseAPI}
 */
export declare class LightningLargeApi extends BaseAPI {
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LightningLargeApi
     */
    streamLightningLargeSpeech(lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<void, any>>;
    /**
     * Converts provided text to speech using the Lightning Large model.
     * @summary Generate speech from text (Lightning Large)
     * @param {LightningLargeRequest} lightningLargeRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LightningLargeApi
     */
    synthesizeLightningLargeSpeech(lightningLargeRequest: LightningLargeRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<File, any>>;
}
/**
 * VoiceCloningApi - axios parameter creator
 * @export
 */
export declare const VoiceCloningApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Instantly clone a voice by uploading an audio file for the specified model.
     * @summary Add a new voice to the model
     * @param {string} displayName Display name for the voice clone.
     * @param {File} file Audio file to create voice clone from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    addVoiceToModel: (displayName: string, file: File, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Deletes a voice clone associated with the authenticated user.
     * @summary Delete a voice clone
     * @param {DeleteVoiceCloneRequest} deleteVoiceCloneRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteVoiceClone: (deleteVoiceCloneRequest: DeleteVoiceCloneRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Fetch your cloned voices.
     * @summary Get Voices
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getClonedVoices: (options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * VoiceCloningApi - functional programming interface
 * @export
 */
export declare const VoiceCloningApiFp: (configuration?: Configuration) => {
    /**
     * Instantly clone a voice by uploading an audio file for the specified model.
     * @summary Add a new voice to the model
     * @param {string} displayName Display name for the voice clone.
     * @param {File} file Audio file to create voice clone from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    addVoiceToModel(displayName: string, file: File, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AddVoiceToModel200Response>>;
    /**
     * Deletes a voice clone associated with the authenticated user.
     * @summary Delete a voice clone
     * @param {DeleteVoiceCloneRequest} deleteVoiceCloneRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteVoiceClone(deleteVoiceCloneRequest: DeleteVoiceCloneRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DeleteVoiceClone200Response>>;
    /**
     * Fetch your cloned voices.
     * @summary Get Voices
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getClonedVoices(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetClonedVoices200Response>>;
};
/**
 * VoiceCloningApi - factory interface
 * @export
 */
export declare const VoiceCloningApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Instantly clone a voice by uploading an audio file for the specified model.
     * @summary Add a new voice to the model
     * @param {string} displayName Display name for the voice clone.
     * @param {File} file Audio file to create voice clone from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    addVoiceToModel(displayName: string, file: File, options?: RawAxiosRequestConfig): AxiosPromise<AddVoiceToModel200Response>;
    /**
     * Deletes a voice clone associated with the authenticated user.
     * @summary Delete a voice clone
     * @param {DeleteVoiceCloneRequest} deleteVoiceCloneRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteVoiceClone(deleteVoiceCloneRequest: DeleteVoiceCloneRequest, options?: RawAxiosRequestConfig): AxiosPromise<DeleteVoiceClone200Response>;
    /**
     * Fetch your cloned voices.
     * @summary Get Voices
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getClonedVoices(options?: RawAxiosRequestConfig): AxiosPromise<GetClonedVoices200Response>;
};
/**
 * VoiceCloningApi - object-oriented interface
 * @export
 * @class VoiceCloningApi
 * @extends {BaseAPI}
 */
export declare class VoiceCloningApi extends BaseAPI {
    /**
     * Instantly clone a voice by uploading an audio file for the specified model.
     * @summary Add a new voice to the model
     * @param {string} displayName Display name for the voice clone.
     * @param {File} file Audio file to create voice clone from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoiceCloningApi
     */
    addVoiceToModel(displayName: string, file: File, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<AddVoiceToModel200Response, any>>;
    /**
     * Deletes a voice clone associated with the authenticated user.
     * @summary Delete a voice clone
     * @param {DeleteVoiceCloneRequest} deleteVoiceCloneRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoiceCloningApi
     */
    deleteVoiceClone(deleteVoiceCloneRequest: DeleteVoiceCloneRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<DeleteVoiceClone200Response, any>>;
    /**
     * Fetch your cloned voices.
     * @summary Get Voices
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoiceCloningApi
     */
    getClonedVoices(options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<GetClonedVoices200Response, any>>;
}
/**
 * VoicesApi - axios parameter creator
 * @export
 */
export declare const VoicesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Fetch voices for a given model.
     * @summary Get Voices
     * @param {GetWavesVoicesModelEnum} model The model to use for speech synthesis.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWavesVoices: (model: GetWavesVoicesModelEnum, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * VoicesApi - functional programming interface
 * @export
 */
export declare const VoicesApiFp: (configuration?: Configuration) => {
    /**
     * Fetch voices for a given model.
     * @summary Get Voices
     * @param {GetWavesVoicesModelEnum} model The model to use for speech synthesis.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWavesVoices(model: GetWavesVoicesModelEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetWavesVoices200Response>>;
};
/**
 * VoicesApi - factory interface
 * @export
 */
export declare const VoicesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Fetch voices for a given model.
     * @summary Get Voices
     * @param {GetWavesVoicesModelEnum} model The model to use for speech synthesis.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWavesVoices(model: GetWavesVoicesModelEnum, options?: RawAxiosRequestConfig): AxiosPromise<GetWavesVoices200Response>;
};
/**
 * VoicesApi - object-oriented interface
 * @export
 * @class VoicesApi
 * @extends {BaseAPI}
 */
export declare class VoicesApi extends BaseAPI {
    /**
     * Fetch voices for a given model.
     * @summary Get Voices
     * @param {GetWavesVoicesModelEnum} model The model to use for speech synthesis.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoicesApi
     */
    getWavesVoices(model: GetWavesVoicesModelEnum, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<GetWavesVoices200Response, any>>;
}
/**
 * @export
 */
export declare const GetWavesVoicesModelEnum: {
    readonly Lightning: "lightning";
    readonly LightningLarge: "lightning-large";
};
export type GetWavesVoicesModelEnum = typeof GetWavesVoicesModelEnum[keyof typeof GetWavesVoicesModelEnum];
